#pragma clang diagnostic ignored "-Wmissing-prototypes"
#pragma clang diagnostic ignored "-Wmissing-braces"

#include <metal_stdlib>
#include <simd/simd.h>

using namespace metal;

template<typename T, size_t Num>
struct spvUnsafeArray
{
    T elements[Num ? Num : 1];
    
    thread T& operator [] (size_t pos) thread
    {
        return elements[pos];
    }
    constexpr const thread T& operator [] (size_t pos) const thread
    {
        return elements[pos];
    }
    
    device T& operator [] (size_t pos) device
    {
        return elements[pos];
    }
    constexpr const device T& operator [] (size_t pos) const device
    {
        return elements[pos];
    }
    
    constexpr const constant T& operator [] (size_t pos) const constant
    {
        return elements[pos];
    }
    
    threadgroup T& operator [] (size_t pos) threadgroup
    {
        return elements[pos];
    }
    constexpr const threadgroup T& operator [] (size_t pos) const threadgroup
    {
        return elements[pos];
    }
};

struct Globals
{
    float4x4 uInvVP;
    float3 uZenith;
    float3 uHorizon;
    float3 uSunDir;
    packed_float3 uSunColor;
    float uStarAlpha;
    float uDayLight;
    char _m7_pad[12];
    packed_float3 uSunsetTint;
    float uSunsetAmt;
    float uCloudAmt;
    float uFancySky;
    float uSkyTime;
    float uCamY;
};

constant spvUnsafeArray<float2, 3> _18 = spvUnsafeArray<float2, 3>({ float2(-1.0), float2(3.0, -1.0), float2(-1.0, 3.0) });

struct main0_out
{
    float3 vRay [[user(locn0)]];
    float4 gl_Position [[position]];
};

vertex main0_out main0(constant Globals& _34 [[buffer(0)]], uint gl_VertexIndex [[vertex_id]])
{
    main0_out out = {};
    float2 ndc = _18[int(gl_VertexIndex)];
    float4 near = _34.uInvVP * float4(ndc, -1.0, 1.0);
    float4 far = _34.uInvVP * float4(ndc, 1.0, 1.0);
    out.vRay = (far.xyz / float3(far.w)) - (near.xyz / float3(near.w));
    out.gl_Position = float4(ndc, 1.0, 1.0);
    out.gl_Position.z = (out.gl_Position.z + out.gl_Position.w) * 0.5;
    return out;
}

